﻿using System.IO.Ports;

namespace HMC8012TrendChart
{
    class CommunicationClass
    {
         SerialPort Port;

         public CommunicationClass()
        {
            Port = new SerialPort();
            Port.WriteTimeout = 2000;
            Port.ReadTimeout = 2000;
            Port.ReadBufferSize = 1024;
            Port.WriteBufferSize = 1024;
        }

         public void SetParameter(string portname, int baudrate, Handshake handshake, Parity parity, StopBits stopbits)
         {
             Port.BaudRate = baudrate;
             Port.Handshake = handshake;
             if (handshake == Handshake.RequestToSend)
                 Port.RtsEnable = true;
             else
                 Port.RtsEnable = false;
             Port.Parity = parity;
             Port.PortName = portname;
             Port.StopBits = stopbits;
         }

        public bool IsOpen()
        {
            return Port.IsOpen;
        }

        public bool WriteString(string s)
        {

            byte[] data = new byte[s.Length];
           
            for (int i = 0; i < s.Length; i++)
            {
                data[i] = (byte)s[i];
            }
            try
            {
                Port.Write(data, 0, data.Length);
                return true;
            }
            catch 
            {
                return false;
            }
        }
        public void Open()
        {
            Port.Open();
        }
        public void Close()
        {
            Port.Close();
        }
        
        public string ReadString()
        {
            byte[] buf = new byte[Port.ReadBufferSize];
            int count = Port.Read(buf, 0, Port.BytesToRead);
            string ret = "";

            for (int i = 0; i < count;i++ )
            {
                ret += (char)buf[i];
            }
            return ret;
        }
    }
}
