﻿using System;
using System.Diagnostics;
using System.Linq;

namespace HMC8012TrendChart
{
    class Program
    {
        static void Main(string[] args)
        {
            string answer = "";
            CommunicationClass io = new CommunicationClass();
            io.SetParameter("COM66", 115200, System.IO.Ports.Handshake.None, System.IO.Ports.Parity.None, System.IO.Ports.StopBits.One);

            io.Open();

            if (io.IsOpen())
            {
                io.WriteString("*IDN?\n");
                System.Threading.Thread.Sleep(200);
                answer = io.ReadString();
                Console.Write(answer);
            }
            
            answer = "";
            Stopwatch timer = new Stopwatch();
            uint Counter = 0;
            timer.Start();

            while (true)
            {
                if (timer.ElapsedMilliseconds > 1000)
                {
                    Console.SetCursorPosition(0, 2);
                    Console.Write(string.Format("M/s: {0}", (float)Counter / timer.ElapsedMilliseconds*1000));
                    Counter = 0;
                    timer.Reset();
                    timer.Start();
                }
                io.WriteString("FETCh?\n");//Schneller aber die gleiche Werte können mehrfach kommen
                //io.WriteString("READ?\n");//Immer aktueller Messwert

                while(!answer.Contains('\n'))
                {
                    System.Threading.Thread.Sleep(1);
                    answer += io.ReadString();
                }

                Console.SetCursorPosition(0, 1);
                Console.Write(float.Parse(answer.Replace('.',',')));
                answer = "";
                Counter++;

            }
        }
    }
}
